#ifndef __interfToolsPanelH__
#define __interfToolsPanelH__

#include <string>
#include <wx/wx.h>
#include "mBarRange.h"
#include <wx/grid.h>

class interfConfigurationPanel 
	: public wxPanel
{
public:
	interfConfigurationPanel(wxWindow * parent);		
	~interfConfigurationPanel();

    

private:

	void onWidthOfContour(wxScrollEvent& event);

	void onBrigthnessColorWindowLevel(wxScrollEvent& event);

	void OnInterpolation(wxCommandEvent& event);

	
	wxSlider* _withOfContourLine;
	wxSlider* _brithtnessWindowLevel;
	wxSlider* _brithtnessColorLevel;
	wxCheckBox* _interpolationCheckBox;	
	
};

class interfSpreadPanel
	: public wxPanel
{
public:
	interfSpreadPanel(wxWindow * parent);		
	~interfSpreadPanel();

    void appendStringSpread(std::string val);
	void setStringSpread(std::string stringtemp);
private:

	wxRadioBox* _spreadMethodRadiobox;
	wxStaticText* _staticTextSpread;
	wxTextCtrl* _wxtextctrlSpread;

	void onSpreadReset(wxCommandEvent& event);
	void onSpreadAdd(wxCommandEvent& event);
	void onSpreadGo(wxCommandEvent& event);

	
		
};

class interfInformationPanel
	: public wxPanel
{
public:
	interfInformationPanel(wxWindow * parent);		
	~interfInformationPanel();

    void setStringInfoPanel(wxString tmpString);
	void setRowLabelInfoPanel(int z,wxString tempString);
	void appendCols(int numcols);
	int getNumberCols();
	void setCellValue(int z,int tmpIntA,wxString tempString);
	void setColLabel(int tmpIntB,wxString tmpTitleString);
	wxString getCellValue(int j,int i);
private:

	mBarRange* _mbarrangeRangeInformation;
	mBarRange* _mbarrangeSliceInformation;
	wxGrid* _grid;
	wxRadioBox* _informationRadiobox;
	wxRadioBox* _radiolstboxContourGroup;
	wxStaticText* _staticTextInformation;
	wxCheckBox* _XYZValues;	
	wxCheckBox* _contourImage;	
	wxCheckBox* _statistics;	

	void onInformationContourLabels(wxCommandEvent& event);
	void onExtractInformation(wxCommandEvent& event);
	void onShowResultImages(wxCommandEvent& event);
	void onSaveResults(wxCommandEvent& event);
	void onContourGroup(wxCommandEvent& event);
	void FillGridWithContoursInformation();
	void onRangeSliceInformation(wxCommandEvent& event);


	
		
};
//CMRU 29-08-09-----------------------------------------------------------------------------------------------
/**
* This class represents the calibration panel in the interface icons
*/
class interfCalibrationPanel
	: public wxPanel
{
public:

	/**
	* Initialized the panel
	* @param parent Window who contains the panel
	*/
	interfCalibrationPanel(wxWindow * parent);	

	~interfCalibrationPanel();

	/**
	* Manages the event associated with the button of calibration
	*/
	void onCalibrate(wxCommandEvent& event);

private:

	/**
	* Text field of the calibration measure
	*/
	wxTextCtrl * _size;

	/**
	* Radio Box with the measurement units
	*/
	wxRadioBox * _unitsRadiobox;
};
//------------------------------------------------------------------------------------------------------------
#endif
 
 
