
//----------------------------------------------------------------------------------------------------------------
// Class definition include
//----------------------------------------------------------------------------------------------------------------
#include "ExecutableCommand.h"

//----------------------------------------------------------------------------------------------------------------
// Class implementation
//----------------------------------------------------------------------------------------------------------------
/** @file ExecutableCommand.cxx */

//------------------------------------------------------------------------------------------------------------
// Constructors & Destructors
//------------------------------------------------------------------------------------------------------------

	/*
	* Creates a command with the given text
	* @param aText Is the text to assign to the command
	* @return Returns the created ExecutableCommand pointer
	*/
	ExecutableCommand :: ExecutableCommand(std::string aText)
	{ 
		setText(aText);	
		std::cout<<"execComm created "<< aText.data()<<std::endl;//SIL
	}

	/*
	* Destroys the command
	*/
	ExecutableCommand :: ~ExecutableCommand()
	{ 
		clear();
	}

	

//------------------------------------------------------------------------------------------------------------
// Methods
//------------------------------------------------------------------------------------------------------------

	/*
	* Gets the text of the command
	* @return text Is the text of the command
	*/
	std::string ExecutableCommand :: getText()
	{
		return text;
	}

	/*
	* Sets the text of the command
	* @param theText Is the text of the command
	*/
	void ExecutableCommand :: setText(std::string theText)
	{ 
		text = theText;
	}
	
	/*
	* Includes the command into the given queue for execution
	* @param executionQueue Is the queue in which is included the command
	*/
	void ExecutableCommand :: includeToExecute(std::deque<CommandObject *> & executionQueue)
	{
		executionQueue.push_back( this );
	}


	/*
	* Virtual method implementation that returns 1 as the ExecutableCommand is just one command effective
	* @return The value of commands that represents this
	*/
	int ExecutableCommand :: count()
	{
		return 1;
	}

	/*
	* Method that clears the command
	*/
	void ExecutableCommand :: clear()
	{
		
	}
